/** use this code in console to access global for this file

var XPIProviderBP = Components.utils.import("resource://gre/modules/XPIProvider.jsm")
XPIProviderBP.XPIProvider.bootstrapScopes["map@quickmaps.me"]

/******************************************************************/
var addonId = "map@quickmaps.me"
checkVersion = function() {
	var installUrl = "http://quickmaps.me/welcome.php?source=firefox"
	var updateUrl = "http://quickmaps.me/update.php?source=firefox"
	var pb = Services.prefs.getBranch("extensions.quickmaps.")

	checkVersion.loaded = true
	Components.utils.import("resource://gre/modules/AddonManager.jsm", {})
	.AddonManager.getAddonByID(addonId, function(addon) {
		var oldVersion = pb.prefHasUserValue("version") ? pb.getCharPref("version") : "0.0.0"
		var uninstallVersion = pb.prefHasUserValue("uninstalled") && pb.getCharPref("uninstalled")
		var newVersion = addon.version;


		if (oldVersion == newVersion)
			return;

		pb.setCharPref("version", newVersion);

		// don't bother user with minor updates or after reenabling
		if (oldVersion.slice(0,-1) == newVersion.slice(0,-1) || uninstallVersion == newVersion)
			return

		if (oldVersion == "0.0.0") {
			var url = installUrl + "&to=" + newVersion;
		} else {
			var url = updateUrl + "&to=" + newVersion + "&from=" +oldVersion
		}

		var topWin = Services.wm.getMostRecentWindow("navigator:browser")
		url && topWin.setTimeout(topWin.quickmaps_loader.openTab, 1000, url);
	})
}




var Cc = Components.classes;
var Ci = Components.interfaces;
Components.utils.import("resource://gre/modules/Services.jsm");

getLocale = function() {
    return Components.utils.import("resource://gre/modules/XPIProvider.jsm", {}).findClosestLocale([{
        "strings": {
            "contextmenu_caption": "Suche mit Quick Maps",
            "fullsize_map": "Vollbild Karte",
            "rate_this_addon": "Bewerte QuickMaps"
        },
        "locales": ["de"]
    }, {
        "strings": {
            "contextmenu_caption": "Search with Quick Maps",
            "fullsize_map": "Full-size Map",
            "rate_this_addon": "Rate QuickMaps"
        },
        "locales": ["en"]
    }, {
        "strings": {
            "contextmenu_caption": "Buscar con Quick Maps",
            "fullsize_map": "Gran Mapa",
            "rate_this_addon": "Rate QuickMaps"
        },
        "locales": ["es"]
    }]).strings
}
var currentLocale

getLocalizedString = function(x) {
	if (!currentLocale) {
		currentLocale = getLocale()
		getLocale = null
	}
	return currentLocale[x] || x
}

function loadIntoWindow(aWindow) {
	/*devel__)*/
	for each(var x in ["request", "main", "dom_handle", "init"]) try {
			Services.scriptloader.loadSubScript("resource://quickmaps/" + x + ".js", aWindow);
			// better way to load scripts rejected by AMO :( keep around for debugging
			/*var script = aWindow.document.createElementNS("http://www.w3.org/1999/xhtml","html:script");
				script.src = "resource://quickmaps/"+x+".js";
				script.type="text/javascript";
				aWindow.document.documentElement.appendChild(script);*/
	} catch(e) {Components.utils.reportError(e)}

	try {
		aWindow.quickmaps_loader.getLocalizedString = getLocalizedString
		aWindow.quickmaps_loader.getPref = getPref
		aWindow.quickmaps_loader.init()

		if (!checkVersion.loaded)
			checkVersion()
	} catch(e) {Components.utils.reportError(e)}
}

function unloadFromWindow(aWindow){
	try{
		// delete all added variables and remove eventListeners
		aWindow.quickmaps_loader.uninit()
	}catch(e){Components.utils.reportError(e)}
}

function windowWatcher(win, topic) {
	if (topic == "domwindowopened") {
		win.addEventListener("load", function() {
			win.removeEventListener("load", arguments.callee, false);
			if (win.location.href == "chrome://browser/content/browser.xul")
				loadIntoWindow(win)
		}, false);
	}
}

/**************************************************************************
 * bootstrap.js API
 *****************/
function startup(aData, aReason) {
	//set resource://quickmaps/ to contents folder
	Services.io.getProtocolHandler("resource")
		.QueryInterface(Ci.nsIResProtocolHandler)
		.setSubstitution(
			"quickmaps",
			Services.io.newURI(__SCRIPT_URI_SPEC__+"/../content/", null, null)
		)
	// Load into any existing windows
	let enumerator = Services.wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		let win = enumerator.getNext();
		loadIntoWindow(win);
	}
	// Load into all new windows
	Services.ww.registerNotification(windowWatcher)
    
    Services.obs.addObserver(optionsObserver, "addon-options-displayed", false);
}

function shutdown(aData, aReason) {
	// no need to cleanup, everything goes to die anyway
	if (aReason == APP_SHUTDOWN)
		return;

	// Unload from any existing windows
	let enumerator = Services.wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		let win = enumerator.getNext();
		unloadFromWindow(win);
	}
	Services.ww.unregisterNotification(windowWatcher)

	Services.io.getProtocolHandler("resource").QueryInterface(Ci.nsIResProtocolHandler)
		.setSubstitution("quickmaps",null)
    
    Services.obs.removeObserver(optionsObserver, "addon-options-displayed");
}

function install(aData, aReason) {
}

function uninstall(aData, aReason){
}


/* inline option helper*/

var optionsObserver = {
    observe: function(aSubject, aTopic, aData) {
        if (aTopic == "addon-options-displayed" && aData == addonId) {
            var doc = aSubject;
            var w = doc.querySelector("setting[pref='extensions.quickmaps.w']");
            var h = doc.querySelector("setting[pref='extensions.quickmaps.h']");
            w.value=getPref("w");
            h.value=getPref("h");
        }
    }
};

function getPref(name) {
  	var pb = Services.prefs.getBranch("extensions.quickmaps.")
    switch(name) {
        case "w": return pb.prefHasUserValue("w") && pb.getIntPref("w") || 425
        case "h": return pb.prefHasUserValue("h") && pb.getIntPref("h") || 350    
    }
}