// thinking of exchaning loop into xPATH lateron
// https://developer.mozilla.org/en/Using_XPath
	
window.quickmaps_dom = {
	_exclNodesRe: /html|body|browser|script|frame|embed|canvas|img|style|code|input|textarea|button/i, // noframe,noscript
	_exclClassRe: /quickmaps/i,
	get _maxSize() 5000,
		
	// seperators:
	get _newLineMaxSize() 150,
	get _inLineRegex() new RegExp(" [A-ZäöüÄÖÜß \.]+ [0-9a-z]+", "ig"),
		
	/* used 4 recurseDom handling */
	zipmatches: null,
				
	recurseDomChildren: function(start){	
		
		var nodes = start.childNodes;
		if(nodes) {
			this.loopNodeChildren(nodes);
		}
	},
		
	loopNodeChildren: function(nodes){
		var node;
		for(var i=0;i<nodes.length;i++){
			node = nodes[i];
			if(node.QUICKMAPS_DONE)
				continue;
			this.processNode(node,i,nodes);
			if(node.childNodes){
				this.recurseDomChildren(node);
			}
		}
	},
	cleanStr: function(str2clean){
		var tmpstr = '';
		tmpstr = str2clean.replace(/^\s+$/g, '').replace(/\s\s+/g,' ').replace(/\n/g,'');
		return tmpstr;
	},
	processNode: function(node,nodepos,allNodes){
		var tmpstr	= '';
		var pos		= '';
		var cnode   = '';
		var matcharr = '';
		var nodeArray = [];
			
		var address	  = '';
		var zipcity   = '';
		var streetno  = '';
		var isNewline = false;
		if(node.nodeType === 1){
			node.QUICKMAPS_DONE = true;
		}else if(node.nodeType === 3){
			//clear whitespace text nodes
			cnode = this.cleanStr(node.data);
			if(cnode){
				for(var i=0;i<this.zipmatches.length;i++){
					pos = cnode.indexOf(this.zipmatches[i]);
					if(pos != -1){
							
						isNewline = false
						streetno = '';
							
						if(nodepos-2 >= 0){
							if(allNodes[nodepos-2].nodeType === 3 && allNodes[nodepos-2].data.length <= 150){
								nodeArray[0] = allNodes[nodepos-2];
								nodeArray[1] = allNodes[nodepos-1];
								streetno = this.cleanStr(allNodes[nodepos-2].data);
								isNewline= true;
							}
						}
							
						if(isNewline){
							nodeArray[2] = node;
							if(typeof allNodes[nodepos+1] != 'undefined'){
								if(allNodes[nodepos+1].nodeName == 'BR'){
									nodeArray[3] = allNodes[nodepos+1];
								}
							}
							zipcity = cnode;
							address = streetno+", "+zipcity;
							quickmaps_req.init(address,zipcity,streetno,nodeArray);



						}else{
							/*
							if(isNewline){
								nodeArray[2] = node;
								if(typeof allNodes[nodepos+1] != 'undefined'){
									if(allNodes[nodepos+1].nodeName == 'BR'){
										nodeArray[3] = allNodes[nodepos+1];
									}
								}
								zipcity = cnode;
								address = streetno+", "+zipcity;
								quickmaps_req.init(address,zipcity,streetno,nodeArray);



							}else{
								/*
								tmpstr		 = cnode.substr(0,pos);
								matcharr = tmpstr.match(this._inLineRegex);
								if(matcharr){

									zipcity = this.zipmatches[i];
									streetno = matcharr[(matcharr.length-1)];
								}
							 */
						}
						this.zipmatches.splice(i, 1);
						break;
					}
				}
			}  
		}
	},
	regular_scan: function(elem){
		// DE regex:
		// 	JsProfiler.setStartTime();
				
		// innerHTML could still contain some "bad tags"
		// maybe use remove_tags from old main again?
		// elem.setAttribute("instantmaps", "done");
		elem.QUICKMAPS_DONE = true;
		var matches_de = elem.innerHTML.match(/\d{5}\s[a-zA-ZäöüÄÖÜß\-\.]+/gi);
		if(matches_de){
			this.zipmatches = matches_de;
			this.recurseDomChildren(elem);
			return;
		}

		var matches_us2 = elem.innerHTML.match(/[a-z,-]+\s[a-z,-]+(\s)\d{5}(-\d{4})?/gi);
		if(matches_us2){
			this.zipmatches = matches_us2;
			this.recurseDomChildren(elem);
			return;
		}
		
		var matches_us = elem.innerHTML.match(/\d{5}(-\d{4})?/gi);
		if(matches_us){
			this.zipmatches = matches_us;
			this.recurseDomChildren(elem);
			return;
		}
		var matches_can = elem.innerHTML.match(/[A-Z]\d[A-Z] \d[A-Z]\d/gi);
		if(matches_can){
			this.zipmatches = matches_can;
			this.recurseDomChildren(elem);
			return;
		}

		/* TODO: was {1,2}\d a typo?*/
		var matches_uk = elem.innerHTML.match(/\d{1,2}[A-Z\d]? \d[ABD-HJLNP-UW-Z]{2}/gi);
		if (matches_uk) {
			this.zipmatches = matches_uk;
			this.recurseDomChildren(elem);
			return;
		}
		//JsProfiler.getDiff();
	},
	isExcluded: function(elem){
		if(elem.QUICKMAPS_DONE) return true;
		if(this._exclNodesRe.test(elem.tagName)) return true; //|| elem.parentNode.tagName.toLowerCase() == 'body'
		if(this._exclClassRe.test(elem.getAttribute("class"))){
			elem.QUICKMAPS_DONE = true;
			return true; //|| elem.parentNode.tagName.toLowerCase() == 'body'
		}
			
		if(typeof elem.innerHTML === "undefined" || elem.innerHTML.length > this._maxSize) return true;
		if(elem.innerHTML.indexOf("quickMapsInfoWindowWrapper") != -1) return true;
		if(elem.innerHTML.indexOf("quickMapsTooltip") != -1) return true;
		if(elem.innerHTML.indexOf("quickmaps") != -1) return true;
		return elem.getAttributeNode("class") == "quickMapsInfoWindow";
		//return /quickMaps/i.test(elem.nodeName)			

		return false;

	},		
	noteOver: function(evt){
		var elem = evt.target || evt.srcElement;
		if(elem && !elem.QUICKMAPS_DONE && !this.isExcluded(elem))
			this.regular_scan(elem)
			
	}
};
