window.quickmaps_apiurl = 'http://maps.google.com/maps/api/geocode/json?address=$aadr$&sensor=false';
window.quickmaps_blacklist = /google/i; // disable quickmaps for those hosts
window.quickmaps_loader = {
	contMen:null,
	lasthost:null,
	lasthostres:null,

	initTooltipStyle: function(on) {
		var sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);

		var uri = makeURI("resource://quickmaps/tooltip/tooltip.css");
		if (sss.sheetRegistered(uri, sss.USER_SHEET))
			sss.unregisterSheet(uri, sss.USER_SHEET);
		if (on)
			sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
	},

	/* Context Menu Handling */
	go2Map: function() {
		var focusedWindow = document.commandDispatcher.focusedWindow;
		var selection = focusedWindow.getSelection();

		var addr2go=selection.toString().replace(/\s+/g,' ').trim();
		if (!addr2go)
		{
			return;
		}
		var map = quickmaps_req.initMap(focusedWindow.document, [addr2go], function(){
			map.style.display = "none";
		})
		quickmaps_req.openMap(map, selection.getRangeAt(0)||focusedWindow.document.popupNode)
	},
	openTab: function(url) {
		var targetTab = gBrowser.addTab(url);
		gBrowser.selectedTab = targetTab;
	},
	onPopupShowing: function(e) {
		var aPopup = e.currentTarget
		var self = quickmaps_loader
		aPopup.insertBefore(self.contMen, document.getElementById("context-sep-" + ((gContextMenu.onLink)?"open":"stop")));
		/*
		Improve handling if needed:
			gContextMenu.isContentSelected ||
						 gContextMenu.onLink ||
						 gContextMenu.onImage ||
						 gContextMenu.onTextInput
		*/
		//self.contMen.hidden = !gContextMenu.onLink && (gContextMenu.isTextSelected || gContextMenu.onImage || gContextMenu.onTextInput);
		self.contMen.hidden = !gContextMenu.isTextSelected;
		self.contMen.setAttribute("disabled", self.contMen.hidden);
	},
	initContextMenu: function() {
		this.contMen = document.createElement("menuitem");
		this.contMen.setAttribute("label", quickmaps_loader.getLocalizedString("contextmenu_caption"));
		this.contMen.setAttribute("accesskey", "i");
		this.contMen.setAttribute("oncommand", "quickmaps_loader.go2Map();");
		this.contMen.setAttribute("class", "menuitem-iconic");
		this.contMen.setAttribute("image", "resource://quickmaps/small_icon.png");

		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.onPopupShowing, false);
	},
	/* Context Menu Handling End */

	init: function(event) {
		this.initTooltipStyle(true);
		this.initContextMenu();
		gBrowser.addEventListener("mouseover", this, false);


	},
	uninit: function() {

		this.initTooltipStyle(false);
		gBrowser.removeEventListener("mouseover", this, false);
		document.getElementById("contentAreaContextMenu").removeEventListener("popupshowing", this.onPopupShowing, false);

		var nodes2remove = Array.slice(document.querySelectorAll("script[src^='resource://quickmaps/']"));
		nodes2remove.push(this.contMen);
		for each(var el in nodes2remove)
			if (el.parentNode)
				el.parentNode.removeChild(el)


		// delete all added variables and remove eventListeners
		delete window.quickmaps

		delete window.quickmaps_apiurl
		delete window.quickmaps_blacklist
		delete window.quickmaps_dom
		delete window.quickmaps_loader
		delete window.quickmaps_req

	},
	inBlacklist: function(){

		if(this.lasthost != window.content.document.location.host){
			this.lasthost = window.content.document.location.host;
			this.lasthostres = quickmaps_blacklist.test(window.content.document.location.host);
		}
		return this.lasthostres;
	},
	handleEvent: function(e){

		if(!this.inBlacklist()){
			quickmaps_req.captureMousePosition(e);
			quickmaps_dom.noteOver(e);
		}
		
	}
};

