window.quickmaps = {
	_inline_seperators: ["|",",","/","-","–","—"], // dynamic regex depending on input
	_br_seperators: ["<br>"],
	/**
		inline seperators are different if you take a close look:
		http://de.wikipedia.org/wiki/Halbgeviertstrich#Gedankenstrich
	*/
	
	// deinfe vars:
	zipacity:	null,
	
	sep2search:	null,
	extractstr:	null,
	
	/**
		Javascript of Firefox "renders" tags and set them to one format
		even if it's different in source:
		
		e.g. <br             /> => <br> in extension
	*/


	/**
		Muster Name, Musterstraße 16, 55555 Berlin
		
		Muster Name<*>
		Musterstraße 16<*>
		55555 Berlin<*>
		
		Muster Name<*>Musterstraße 16<*>55555 Berlin<*>
	*/
	trim: function(strtotrim){
		 strtotrim = strtotrim.replace(/^\s\s*/g, '').replace(/\s\s*$/g, '');
		 return strtotrim;	
	},
	
	strip_tags: function(strtostrip){		
		 strtostrip = strtostrip.replace(/<\/?[^>]+>/gi, ' ');
		 strtostrip = this.trim(strtostrip);
		 return strtostrip;
	},
	
	format_br: function(){

		// maybe improve it later on by combining it with the old regex:
		// sub_matches = tmpstr.match(/[a-zA-ZäöüÄÖÜß \-\.]+ [0-9]/gi);
		var tmpaddr = '';
		var matcharr = this.extractstr.match(/<br>([^<].+)([0-9]+)([^<]+)<br>/img); // limited to br
		if(!matcharr){
			matcharr = this.extractstr.match(/<\/?[^>]+>([^<]+)([0-9]+)([^<]+)<br>/img);
			if(!matcharr) return false;
		}
		// take maximum of two results
		// only the last two will be taken!
		if(matcharr.length >= 2){
			tmpaddr = this.strip_tags(matcharr[(matcharr.length-2)])+", "+this.strip_tags(matcharr[(matcharr.length-1)])+', ';
		}else{
			tmpaddr = this.strip_tags(matcharr[0])+', ';
		}
		tmpaddr += this.zipacity;




		quickmaps_req.init(tmpaddr,'',this.strip_tags(this.zipacity),this.strip_tags(matcharr[(matcharr.length-1)]));
		//quickmaps_req.init("Turmstraße"); would return more then one address!
	},
	
	fortmat_inline: function(){


		var tmpaddr = '';
		var tmpregex = '';
		
		for(var i=0; i<this._inline_seperators.length; i++){
			tmpregex += this._inline_seperators[i];
		}
					
		var regex = new RegExp("(["+tmpregex+"])([^<>"+tmpregex+"]+)(["+tmpregex+"])", "ig"); 
		var matcharr = this.extractstr.match(regex);
		
		if(!matcharr) return false;
		regex = new RegExp("(["+tmpregex+"])", "ig"); 
		for(i=0;i<matcharr.length;i++){
			matcharr[i] = matcharr[i].replace(regex,'');
		}
		// take maximum of two results
		// only the last two will be taken!
		if(matcharr.length >= 2){
			tmpaddr = this.strip_tags(matcharr[(matcharr.length-2)])+", "+this.strip_tags(matcharr[(matcharr.length-1)])+', ';
		}else{
			tmpaddr = this.strip_tags(matcharr[0])+', ';
		}
		tmpaddr += this.zipacity;



		
		quickmaps_req.init(tmpaddr,'',this.strip_tags(this.zipacity),this.strip_tags(matcharr[(matcharr.length-1)]));
	},
	
	array_in_array: function(str2search,arrays_seperators){
		for(var i=0;i<arrays_seperators.length;i++){
			if(str2search.indexOf(arrays_seperators[i]) != -1) return true;
		}
		return false;
	},
	
	street_scan: function(){
		// format_br has priority
		if(this.array_in_array(this.sep2search,this._br_seperators)){
			this.format_br();
			return "br format";
		}
		
		if(this.array_in_array(this.sep2search,this._inline_seperators)){
			this.fortmat_inline();
			return "inline format";
		}
		
		//return false;



		for(var i=0;i<this.sep2search.length;i++){

		}
		
		return false;
		//if(str.indexOf(this._seperators) != -1) return true;
		//return false;
	},
	
	
	array_unique: function(ar){
		if(ar.length && typeof ar!=='string'){
			var sorter = {};
			var out = [];
			for(var i=0,j=ar.length;i<j;i++){
				if(!sorter[ar[i]+typeof ar[i]]){
					out.push(ar[i]);
					sorter[ar[i]+typeof ar[i]]=true;
				}
			}
		}
		return out || ar;
	},
	
	regular_scan: function(doc){
		quickmaps_req.TooltipAppend();
		var htmlsrc 	= doc;
					
		var matches = htmlsrc.match(/\d{5}\s[a-zA-ZäöüÄÖÜß\-\.]+/gi);
		this.sep2search	= "";
		this.extractstr	= "";
		var num_char	= 0;
		var last_finding= 0;
		//charCodeAt
		var i=0;
		var loopC=0;
		
		if(matches){
			matches = this.array_unique(matches);
			for(i=0; i<matches.length; i++){
				
				num_char = 0;
				loopC 	 = 0;
				last_finding = htmlsrc.lastIndexOf(matches[i]);
				
				while (num_char != -1 && num_char != last_finding) {
					num_char = htmlsrc.indexOf(matches[i],loopC);
					
					this.sep2search = htmlsrc.substr((num_char-15),15);
					this.extractstr = htmlsrc.substr((num_char-150),150);
					this.zipacity	= matches[i];
					loopC = num_char+1;


				}
				
				//quickmaps_devel.debug("htmlsrc: "+htmlsrc);
				//quickmaps_devel.debug("Tmpstr: "+tmpstr);
				//quickmaps_devel.debug("Valild Seperator: "+this.street_scan());
				//quickmaps_devel.debug("Submatch: "+sub_matches[sub_matches.length-1]);
				
				/*
				if(htmlsrc[num_char-1].indexOf(allowed_seperator) != -1){

				}else{

				}
				
				for(j=(num_char-1);j>num_char-5;j--){

				}
				*/
			}
		}
	},
	
	scandoc: function(doc){
		this.regular_scan(doc);
	}
	
};

