window.quickmaps_req = {
	current_tag: '',
	current_addr:'',
	dtd:"http://www.w3.org/1999/xhtml",
	captureMousePosition:function(e){
		this.mouseX = e.clientX;
		this.mouseY = e.clientY;
	},

	updateZOrder: function(mapEl){
		if (mapEl.style.zIndex != "2147483600"){
			var ch = mapEl.ownerDocument.querySelectorAll(".quickMapsInfoWindow")
			for (var i = ch.length; i--;)
				ch[i].style.zIndex = "";
			mapEl.style.zIndex = "2147483600" // 2147483646
		}
	},

	moveElement : function(e) {
		if (window.moveElementDebug){
			window.moveElementDebug(e)
			return
		}

		// bring clicked map to the top
		quickmaps_req.updateZOrder(e.currentTarget)

		// move map
       	if(e.target.nodeName.toLowerCase()!="quickmaps-drag")
			return;

		var onMouseMove = function(e){
            var l = Math.min(Math.max(0,left + e.clientX - x),maxL)
            var t = Math.max(0,top + e.view.pageYOffset + e.clientY - y)

			target.style.left = l+"px"
			target.style.top = t+"px"
            e.preventDefault()
            e.stopPropagation()
		}
		var onMouseUp = function(e){
			target.removeEventListener("mousemove", onMouseMove, false)
			target.removeEventListener("mouseup", onMouseUp, true)
			target.classList.remove("dragging")

			target = null
		}

		var target = e.currentTarget;

		var x = e.clientX, y = e.clientY;
		var rect = target.getBoundingClientRect();
		var top = parseInt(target.style.top) - e.view.pageYOffset
        var left = parseInt(target.style.left);

        var maxL = target.ownerDocument.documentElement.scrollWidth - rect.width -12

		target.classList.add("dragging");
		target.setCapture(true)
		target.addEventListener("mousemove", onMouseMove, false)
		target.addEventListener("mouseup", onMouseUp, true)
        e.preventDefault()
        e.stopPropagation()
	},
	resizeElement : function(e){
       	if(e.target != e.currentTarget)
			return;

		var onMouseMove = function(e){
		    ifr.style.height = h+e.clientY - y+"px"
		    ifr.style.width = b.style.width = Math.max(w+e.clientX - x, 80)+"px"

            e.preventDefault()
            e.stopPropagation()
		}
		var onMouseUp = function(e){
			target.removeEventListener("mousemove", onMouseMove, false)
			target.removeEventListener("mouseup", onMouseUp, true)
			target.classList.remove("resizing")

			target = ifr = b = null
		}

		var target = e.target
		var ifr = target.parentNode.querySelector("iframe")
		var b = target.parentNode.querySelector(".quickMapsInputWrapper")
        var r1 = ifr.getBoundingClientRect()
		var h = r1.height,  w = r1.width

		var x = e.clientX, y = e.clientY;
		var rect = target.parentNode.getBoundingClientRect();

        var maxW = target.ownerDocument.documentElement.scrollWidth - rect.width -12

		target.classList.add("resizing");
		target.setCapture(true)
		target.addEventListener("mousemove", onMouseMove, false)
		target.addEventListener("mouseup", onMouseUp, true)
        e.preventDefault()
        e.stopPropagation()
	},
	
	navigationBoxEvent: function(e){
		if(e && e.type!="click" && e.keyCode!=13)
			return;

		var wrap = e.currentTarget.parentNode;
		if(wrap.firstChild.value != ""){
			wrap.parentNode.querySelector("iframe").setAttribute("src", quickmaps_req.buildIframeUri("q="+encodeURIComponent(wrap.firstChild.value)));
		}
	},
 
	buildIframeUri: function( params ){
		// build a DOM 
		var page = "<html>"
		         + "  <head>"
		         + "    <meta name='viewport' content='initial-scale=1.0, user-scalable=no'/>"
		         + "  </head>"
		         + "  <body style='margin:0; padding:0;'>"
		         + "    <div id='map_canvas' style='width:100%; height:100%'></div>"
		         + "    <script type='text/javascript' src='http://quickmaps.me/maps.js?"+params+"'><\/script>"
		         + "  </body>"
		         + "</html>";
		// create a data url
		return "data:text/html;charset=utf-8," + (encodeURIComponent(page));
	},

	createMap: function(addr,cord, onclose){

		// z = zoom!
		if (cord) {
			var viewport_n = ''+cord[2]+', '+cord[3]+'';
			var viewport_s = ''+cord[4]+', '+cord[5]+'';
			var IgUrl = this.buildIframeUri("q="+encodeURIComponent(addr));
			var AgUrl = 'http://maps.google.com/maps?q='+encodeURIComponent(addr)+'&ie=UTF8';
		} else {
			IgUrl = AgUrl = 'http://maps.google.com/maps?q='+encodeURIComponent(addr)+'&ie=UTF8';
		}

		var wrap = document.createElementNS(this.dtd,"quickmaps-drag");
		wrap.setAttribute("class","quickMapsInfoWindowInner");
		wrap.QUICKMAPS_DONE = true;

		var c = document.createElementNS(this.dtd, "quickmaps-span");
		c.setAttribute("class","quickMapsClose-btn");
		c.setAttribute("title","Close");
		c.addEventListener("click",onclose,false);

		var r = document.createElementNS(this.dtd, "quickmaps-span");
		r.setAttribute("class","quickMapsResize-btn");
		r.addEventListener("mousedown",this.resizeElement,false);

		var inwrap = document.createElementNS(this.dtd, "quickmaps-drag");
		inwrap.QUICKMAPS_DONE = true;
		inwrap.setAttribute("class","quickMapsInputWrapper");

		var inp = document.createElementNS(this.dtd, "input");
		inp.setAttribute("type","text");
		inp.setAttribute("value",addr);
		inp.addEventListener("keypress",this.navigationBoxEvent,false);
		var inbtn = document.createElementNS(this.dtd, "a");
		inbtn.setAttribute("class","quickMapsButton");
		inbtn.addEventListener("click",this.navigationBoxEvent,false);
		inbtn.appendChild(document.createTextNode("Search"));

		inwrap.appendChild(inp);
		inwrap.appendChild(inbtn);

		var ifr = document.createElementNS(this.dtd, "iframe");
		ifr.QUICKMAPS_DONE = true;
		ifr.setAttribute("width", quickmaps_loader.getPref("w"));
		ifr.setAttribute("height", quickmaps_loader.getPref("h"));
		ifr.setAttribute("frameborder","0");
		ifr.setAttribute("scrolling","0");
		ifr.setAttribute("marginheight","0");
		ifr.setAttribute("marginwidth","0");
		ifr.setAttribute("src",this.buildIframeUri("q="+encodeURIComponent(addr)));
		ifr.setAttribute("class","quickMapsIFR");

		var full = document.createElementNS(this.dtd, "quickmaps-drag");
		full.QUICKMAPS_DONE = true;
		full.setAttribute("class","quickMapsLink");
		full.setAttribute("align","right");

    var ratea = document.createElementNS(this.dtd, "a");
    ratea.setAttribute("target","_blank");
    ratea.setAttribute("href","https://addons.mozilla.org/de/firefox/addon/quick-maps/");
    ratea.setAttribute("class","left");
    ratea.appendChild(document.createTextNode(
      quickmaps_loader.getLocalizedString("rate_this_addon")
    ));
    full.appendChild(ratea);

		var fulla = document.createElementNS(this.dtd, "a");
		fulla.setAttribute("target","_blank");
		fulla.setAttribute("href",AgUrl);
    fulla.setAttribute("class","right");
		fulla.appendChild(document.createTextNode(
			quickmaps_loader.getLocalizedString("fullsize_map")
		));
    full.appendChild(fulla);

		wrap.appendChild(c);
		wrap.appendChild(r);
		wrap.appendChild(inwrap);
		wrap.appendChild(ifr);
		wrap.appendChild(full);


		return wrap;
	},
	
	getMapContainer: function(document){
		var el = document.querySelector("quickmaps-main-container")
		if (el)
			return el
		var el = document.createElementNS(this.dtd, "quickmaps-main-container");
		var st = el.style
		st.height = st.width = '0'
		document.documentElement.appendChild(el)
		return el
	},

	initMap: function(document, mapData, onClose){
		var innerMap = this.createMap(mapData[0],mapData[1], onClose);
		
		var map = document.createElementNS(this.dtd, "quickmaps-drag");
		map.setAttribute("class","quickMapsInfoWindow");
		map.appendChild(innerMap);
		map.addEventListener("mousedown",this.moveElement,false);
		this.getMapContainer(document).appendChild(map);
		
		return map
	},

	openMap: function(map, anchorRect, tooltipRect){
		if (!tooltipRect)
			tooltipRect = {width:0, height:0};			
		if (!anchorRect)
			anchorRect = {top:this.mouseY, left:this.mouseX}

		var rect = anchorRect.getBoundingClientRect
			? anchorRect.getBoundingClientRect()
			: anchorRect

		// unhide the map before computing its' size
		map.style.display = "block";
		var mapRect = map.getBoundingClientRect()
		var window = map.ownerDocument.defaultView

		var left = rect.left + 5 + tooltipRect.width
		if (left + mapRect.width > window.innerWidth - 18 - 12) {
			// try to flip side
			if (rect.left - mapRect.width > 0)
				left = rect.left - mapRect.width
			else
				left = window.innerWidth - 18 - 12 - mapRect.width
		}
		if (left < 0)
			left = 0

		var top = rect.top - 70 - tooltipRect.height*0.5 - mapRect.height*0.25
		if (top + mapRect.height > window.innerHeight)
			top =  window.innerHeight - mapRect.height
		if (top < 13)
			top = 13

		map.style.position = "absolute";
		map.style.top =  window.pageYOffset + top  + 'px';
		map.style.left = window.pageXOffset + left + 'px';

		quickmaps_req.updateZOrder(map)	
	},
	createTooltip: function(refNodes,nodes2wrap,mapData){
		var ttm = this.createToolTipMap();
		var timer, map, swrapRect;
		var timeMouseOut = null, timeMouseOver = null, ttmRect;


		nodes2wrap.setAttribute("open", "false")

		var parent = refNodes[0].parentNode;



		var swrap = document.createElementNS(this.dtd,"span");
		swrap.appendChild(nodes2wrap);
		swrap.QUICKMAPS_DONE = true;
		swrap.setAttribute("class","quickMapsTooltip");

		parent.insertBefore(swrap, refNodes[0]);

		var closeMap = function(){
			nodes2wrap.setAttribute("open", "false");
			map.style.display = "none";
		}

		var openMap = this.openMap
		var closeTTM = function() {
			clearTimeout(timer);
			clearTimeout(timeMouseOut);
			timer = timeMouseOut = null
			
			if (!map || !map.parentNode) {
				map = quickmaps_req.initMap(swrap.ownerDocument, mapData, closeMap)
			}

			nodes2wrap.setAttribute("open", "true");
			if(ttm.parentNode) {
				ttmRect = ttm.getBoundingClientRect()
				ttm.parentNode.removeChild(ttm);
			}
			
			openMap(map, swrapRect, ttmRect);
		};
		

		function onMouseOver(){
			if(nodes2wrap.getAttribute("open") != "false")
				return
			window.clearTimeout(timeMouseOut);
			if(!ttm)
				return
			if (timer != null)
				return

			ttm.style.display = "block";
			if (!ttm.parentNode)
				quickmaps_req.getMapContainer(swrap.ownerDocument).appendChild(ttm)
			
			var doc = swrap.ownerDocument
			var view = doc.defaultView
			// find first TEXT_NODE child
			var child = swrap, rect
			while (child && child.nodeType != 3)
				child = child.firstChild

			if (child && child.nodeType == 3){
				var range = document.createRange()
				range.selectNodeContents(child);
				rect = range.getClientRects()[0]
				range.detach()
			} 
			swrapRect = rect = rect || swrap.getBoundingClientRect()
			
			var x = rect.width <= 120 && rect.left > 120 ? -30 : 5
				
			ttm.style.top  = view.pageYOffset + rect.top - 70 +'px';
			ttm.style.left = view.pageXOffset + rect.left + x +'px';

			timer = window.setTimeout(closeTTM, 2500);
		}
		function isOpener(node){
			while (node) {
				if (node == ttm || node == nodes2wrap)
					return true
				node = node.parentNode
			}
			return false
		}		
		function onMouseOut(e){
			if (isOpener(e.reletedTarget))
				return
			window.clearTimeout(timeMouseOut)
			timeMouseOut = window.setTimeout(function(){
				window.clearTimeout(timer);
				timer = null
				if(ttm.parentNode)
					ttm.parentNode.removeChild(ttm);
			}, 350);

		}

		nodes2wrap.addEventListener("mouseover", onMouseOver, false);
		nodes2wrap.addEventListener("mouseout", onMouseOut, false);

		ttm.addEventListener("mouseover", onMouseOver, false);
		ttm.addEventListener("mouseout", onMouseOut, false);
		

		nodes2wrap.addEventListener("click", closeTTM, false);

		ttm.addEventListener("click", closeTTM, false);

		for(var i=0;i<refNodes.length;i++){
			parent.removeChild(refNodes[i]);
		}
		return true;
	},
	createToolTipMap:function(){
		var bubble = document.createElementNS(this.dtd,"div");
		bubble.setAttribute("class","quickMapsToolTip");
		bubble.appendChild(document.createTextNode("Quick Maps"));
		bubble.QUICKMAPS_DONE = true;
		
		var loader = document.createElementNS(this.dtd,"div");
		loader.setAttribute("class", "quickmapstooltipmaploader");
		bubble.appendChild(loader);
		
		bubble.style.display = "block";
		bubble.style.position = "absolute";
		return bubble;
	},


	/********************************************************/
	is_addr_valid: function(json,zipacity,street,node){
		if(street.length < 4){

			return false;
		}
		try{
			var xhrReturn = JSON.parse(json);
		}catch(e){

			return false;
		}

		if(!xhrReturn){

			return false;
		}

		if(xhrReturn.status != 'OK'){

			return false;
		}

		if(xhrReturn.results.length > 5){

			return false;
		}

		/**
			if(xhrReturn.results[0]["geometry"]["location_type"] == "APPROXIMATE"){ // strict mode

				return false;
			}
		 */


		if(street[0] == ' '){
			if(street[street.length-1] == ' '){
				street = street.substr(1,(street.length-1));
			}
		}

		var addr = street+' '+zipacity;
		if(typeof xhrReturn.results[0]["geometry"]["viewport"]["northeast"] != "undefined" && typeof xhrReturn.results[0]["geometry"]["viewport"]["southwest"] != "undefined"){
			var cord = new Array(xhrReturn.results[0]["geometry"]["location"]["lat"],xhrReturn.results[0]["geometry"]["location"]["lng"],xhrReturn.results[0]["geometry"]["viewport"]["northeast"]["lat"],xhrReturn.results[0]["geometry"]["viewport"]["northeast"]["lng"],xhrReturn.results[0]["geometry"]["viewport"]["southwest"]["lat"],xhrReturn.results[0]["geometry"]["viewport"]["southwest"]["lng"]);
		}else{
			var cord = new Array(xhrReturn.results[0]["geometry"]["location"]["lat"],xhrReturn.results[0]["geometry"]["location"]["lng"],0,0,0,0);
		}
		var nodes2wrap = document.createElementNS(this.dtd,"div");
		nodes2wrap.setAttribute("class","quickMapsInfoWindowWrapper");
		var clone = '';
		for(var i=0;i<node.length;i++){
			clone = node[i].cloneNode(true)
			nodes2wrap.appendChild(clone);
		}

		this.createTooltip(node,nodes2wrap,[addr, cord]);

		return true;
	},

	filter_addr: function(address){
		if(address.length > 255) return false;
		if(address.length < 3)   return false;
		return encodeURIComponent(address);
	},

	init: function(address,zipacity,street,node){

		var clear_addr = this.filter_addr(address);
		if(!clear_addr) return false;
		var gapi_url = quickmaps_apiurl.replace('$aadr$', clear_addr);

		var req = Cc["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
		req.open('GET',gapi_url, true); // true == asyncron

		req.onload = function() {

			quickmaps_req.is_addr_valid(req.responseText,zipacity,street,node);
		}

		req.send(null);
	}
}